Index: /trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk	(revision 25135)
+++ /trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk	(revision 25136)
@@ -307,5 +307,4 @@
 	include/VBoxVMLogViewer.h \
 	include/VBoxMediaManagerDlg.h \
-	include/VBoxSettingsUtils.h \
 	include/VBoxVMSettingsGeneral.h \
 	include/VBoxVMSettingsSystem.h \
@@ -335,5 +334,7 @@
 	include/VBoxExportApplianceWgt.h \
 	include/VBoxExportApplianceWzd.h \
-	include/VBoxSpecialControls.h
+	include/VBoxSpecialControls.h \
+	include/VBoxBootTable.h \
+	include/VBoxWarningPane.h
 
 # Sources containing local definitions of classes that use the Q_OBJECT macro.
@@ -435,5 +436,7 @@
 	src/VBoxExportApplianceWgt.cpp \
 	src/VBoxExportApplianceWzd.cpp \
-	src/VBoxSpecialControls.cpp
+	src/VBoxSpecialControls.cpp \
+	src/VBoxBootTable.cpp \
+	src/VBoxWarningPane.cpp
 
 ifeq ($(filter-out freebsd linux netbsd openbsd solaris,$(KBUILD_TARGET)),) # X11
Index: /trunk/src/VBox/Frontends/VirtualBox/include/VBoxBootTable.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/include/VBoxBootTable.h	(revision 25136)
+++ /trunk/src/VBox/Frontends/VirtualBox/include/VBoxBootTable.h	(revision 25136)
@@ -0,0 +1,60 @@
+/** @file
+ *
+ * VBox frontends: Qt4 GUI ("VirtualBox"):
+ * VBoxBootTable class declaration
+ */
+
+/*
+ * Copyright (C) 2009 Sun Microsystems, Inc.
+ *
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ *
+ * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+ * Clara, CA 95054 USA or visit http://www.sun.com if you need
+ * additional information or have any questions.
+ */
+
+#ifndef __VBoxBootTable_h__
+#define __VBoxBootTable_h__
+
+/* Global includes */
+#include <QTreeWidget>
+
+/**
+ *  QTreeWidget class reimplementation to use as boot items table.
+ *  It has one unsorted column without header.
+ *  Keymapping handlers for ctrl-up & ctrl-down are translated into
+ *  boot-items up/down moving signals.
+ *  Emits itemToggled() signal when the item changed.
+ */
+class VBoxBootTable : public QTreeWidget
+{
+    Q_OBJECT;
+
+public:
+
+    VBoxBootTable(QWidget *pParent);
+
+signals:
+
+    void moveItemUp();
+    void moveItemDown();
+    void itemToggled();
+
+protected:
+
+    void keyPressEvent(QKeyEvent *pEvent);
+
+private slots:
+
+    void onItemChanged();
+};
+
+#endif // __VBoxBootTable_h__
+
Index: /trunk/src/VBox/Frontends/VirtualBox/include/VBoxSettingsDialog.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/include/VBoxSettingsDialog.h	(revision 25135)
+++ /trunk/src/VBox/Frontends/VirtualBox/include/VBoxSettingsDialog.h	(revision 25136)
@@ -35,5 +35,5 @@
 
 /* VBox forwards*/
-class VBoxWarnIconLabel;
+class VBoxWarningPane;
 class VBoxSettingsSelector;
 class VBoxSettingsPage;
@@ -106,5 +106,5 @@
     QPixmap mErrorIcon;
     QPixmap mWarnIcon;
-    VBoxWarnIconLabel *mIconLabel;
+    VBoxWarningPane *mIconLabel;
 
     /* WhatsThis Stuff */
Index: unk/src/VBox/Frontends/VirtualBox/include/VBoxSettingsUtils.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/include/VBoxSettingsUtils.h	(revision 25135)
+++ 	(revision )
@@ -1,178 +1,0 @@
-/** @file
- *
- * VBox frontends: Qt4 GUI ("VirtualBox"):
- * VBoxSettingsUtils class declaration
- */
-
-/*
- * Copyright (C) 2006-2008 Sun Microsystems, Inc.
- *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
- * Clara, CA 95054 USA or visit http://www.sun.com if you need
- * additional information or have any questions.
- */
-
-#ifndef __VBoxSettingsUtils_h__
-#define __VBoxSettingsUtils_h__
-
-#include <VBoxGlobal.h>
-
-/* Qt includes */
-#ifdef Q_WS_WIN
-#include <QDialog>
-#include <QLineEdit>
-#include <QPushButton>
-#endif
-#include <QHBoxLayout>
-#include <QLabel>
-#include <QTreeWidget>
-#include <QHeaderView>
-#include <QKeyEvent>
-#include <QTableView>
-
-enum
-{
-    /* mTwUSBFilters column numbers */
-    twUSBFilters_Name = 0,
-};
-
-/**
- *  QTreeWidget class reimplementation to use as boot items table.
- *  It has one unsorted column without header.
- *  Keymapping handlers for ctrl-up & ctrl-down are translated into
- *  boot-items up/down moving signals.
- *  Emits itemToggled() signal when the item changed.
- */
-class BootItemsTable : public QTreeWidget
-{
-    Q_OBJECT;
-
-public:
-
-    BootItemsTable (QWidget *aParent) : QTreeWidget (aParent)
-    {
-        header()->hide();
-        connect (this, SIGNAL (itemChanged (QTreeWidgetItem *, int)),
-                 this, SLOT (onItemChanged()));
-    }
-
-   ~BootItemsTable() {}
-
-signals:
-
-    void moveItemUp();
-    void moveItemDown();
-    void itemToggled();
-
-private slots:
-
-    void onItemChanged()
-    {
-        emit itemToggled();
-    }
-
-    void keyPressEvent (QKeyEvent *aEvent)
-    {
-        if (aEvent->QInputEvent::modifiers () == Qt::ControlModifier)
-        {
-            switch (aEvent->key())
-            {
-                case Qt::Key_Up:
-                    emit moveItemUp();
-                    return;
-                case Qt::Key_Down:
-                    emit moveItemDown();
-                    return;
-                default:
-                    break;
-            }
-        }
-        QTreeWidget::keyPressEvent (aEvent);
-    }
-};
-
-class USBListItem : public QTreeWidgetItem
-{
-public:
-
-    enum { USBListItemType = 1002 };
-
-    USBListItem (QTreeWidget *aParent)
-        : QTreeWidgetItem (aParent, QStringList (QString::null), USBListItemType)
-        , mId (-1) {}
-
-    USBListItem (QTreeWidget *aParent, QTreeWidgetItem *aPreceding)
-        : QTreeWidgetItem (aParent, aPreceding, USBListItemType)
-        , mId (-1) {}
-
-    int mId;
-};
-
-/**
- *  Table-View class reimplementation to extend standard QTableView.
- */
-class QITableView : public QTableView
-{
-    Q_OBJECT;
-
-public:
-
-    QITableView (QWidget *aParent) : QTableView (aParent) {}
-
-signals:
-
-    void currentChanged (const QModelIndex &aCurrent);
-
-protected:
-
-    void currentChanged (const QModelIndex &aCurrent,
-                         const QModelIndex &aPrevious)
-    {
-        QTableView::currentChanged (aCurrent, aPrevious);
-        emit currentChanged (aCurrent);
-    }
-
-    void focusInEvent (QFocusEvent *aEvent)
-    {
-        /* Restore edit-mode on focus in. */
-        QTableView::focusInEvent (aEvent);
-        if (model()->flags (currentIndex()) & Qt::ItemIsEditable)
-            edit (currentIndex());
-    }
-};
-
-class VBoxWarnIconLabel: public QWidget
-{
-    Q_OBJECT;
-
-public:
-
-    VBoxWarnIconLabel (QWidget *aParent = NULL)
-        : QWidget (aParent)
-    {
-        QHBoxLayout *layout = new QHBoxLayout (this);
-        VBoxGlobal::setLayoutMargin (layout, 0);
-        layout->addWidget (&mIcon);
-        layout->addWidget (&mLabel);
-        setVisible (false);
-    }
-
-    void setWarningPixmap (const QPixmap& aPixmap) { mIcon.setPixmap (aPixmap); }
-    void setWarningText (const QString& aText) { mLabel.setText (aText); }
-
-private:
-
-    QLabel mIcon;
-    QLabel mLabel;
-};
-
-#endif // __VBoxSettingsUtils_h__
-
Index: /trunk/src/VBox/Frontends/VirtualBox/include/VBoxWarningPane.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/include/VBoxWarningPane.h	(revision 25136)
+++ /trunk/src/VBox/Frontends/VirtualBox/include/VBoxWarningPane.h	(revision 25136)
@@ -0,0 +1,48 @@
+/** @file
+ *
+ * VBox frontends: Qt4 GUI ("VirtualBox"):
+ * VBoxWarningPane class declaration
+ */
+
+/*
+ * Copyright (C) 2009 Sun Microsystems, Inc.
+ *
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ *
+ * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+ * Clara, CA 95054 USA or visit http://www.sun.com if you need
+ * additional information or have any questions.
+ */
+
+#ifndef __VBoxWarningPane_h__
+#define __VBoxWarningPane_h__
+
+/* Global includes */
+#include <QWidget>
+#include <QLabel>
+
+class VBoxWarningPane: public QWidget
+{
+    Q_OBJECT;
+
+public:
+
+    VBoxWarningPane(QWidget *pParent = 0);
+
+    void setWarningPixmap(const QPixmap &imgPixmap);
+    void setWarningText(const QString &strText);
+
+private:
+
+    QLabel m_icon;
+    QLabel m_label;
+};
+
+#endif // __VBoxWarningPane_h__
+
Index: /trunk/src/VBox/Frontends/VirtualBox/src/VBoxBootTable.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/VBoxBootTable.cpp	(revision 25136)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/VBoxBootTable.cpp	(revision 25136)
@@ -0,0 +1,61 @@
+/** @file
+ *
+ * VBox frontends: Qt4 GUI ("VirtualBox"):
+ * VBoxBootTable class implementation
+ */
+
+/*
+ * Copyright (C) 2009 Sun Microsystems, Inc.
+ *
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ *
+ * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+ * Clara, CA 95054 USA or visit http://www.sun.com if you need
+ * additional information or have any questions.
+ */
+
+/* Global include */
+#include <QHeaderView>
+#include <QKeyEvent>
+
+/* Local includes */
+#include "VBoxBootTable.h"
+#include "VBoxGlobal.h"
+
+VBoxBootTable::VBoxBootTable(QWidget *pParent)
+    : QTreeWidget(pParent)
+{
+    header()->hide();
+    connect(this, SIGNAL(itemChanged(QTreeWidgetItem *, int)), this, SLOT(onItemChanged()));
+}
+
+void VBoxBootTable::onItemChanged()
+{
+    emit itemToggled();
+}
+
+void VBoxBootTable::keyPressEvent(QKeyEvent *pEvent)
+{
+    if (pEvent->QInputEvent::modifiers() == Qt::ControlModifier)
+    {
+        switch (pEvent->key())
+        {
+            case Qt::Key_Up:
+                emit moveItemUp();
+                return;
+            case Qt::Key_Down:
+                emit moveItemDown();
+                return;
+            default:
+                break;
+        }
+    }
+    QTreeWidget::keyPressEvent(pEvent);
+}
+
Index: /trunk/src/VBox/Frontends/VirtualBox/src/VBoxSettingsDialog.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/VBoxSettingsDialog.cpp	(revision 25135)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/VBoxSettingsDialog.cpp	(revision 25136)
@@ -21,5 +21,5 @@
  */
 #include "VBoxSettingsDialog.h"
-#include "VBoxSettingsUtils.h"
+#include "VBoxWarningPane.h"
 #include "VBoxGlobal.h"
 #include "VBoxProblemReporter.h"
@@ -47,5 +47,5 @@
     , mValid (true)
     , mSilent (true)
-    , mIconLabel (new VBoxWarnIconLabel (this))
+    , mIconLabel (new VBoxWarningPane (this))
     , mWhatsThisTimer (new QTimer (this))
     , mWhatsThisCandidate (0)
Index: /trunk/src/VBox/Frontends/VirtualBox/src/VBoxSettingsSelector.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/VBoxSettingsSelector.cpp	(revision 25135)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/VBoxSettingsSelector.cpp	(revision 25136)
@@ -21,12 +21,14 @@
  */
 
+/* Global includes */
+#include <QHeaderView>
+#include <QTabWidget>
+
+/* Local includes */
 #include "VBoxSettingsSelector.h"
-#include "VBoxSettingsUtils.h"
 #include "VBoxSettingsPage.h"
+#include "VBoxGlobal.h"
+#include "VBoxToolBar.h"
 #include "QITreeWidget.h"
-#include "VBoxToolBar.h"
-
-/* Qt includes */
-#include <QTabWidget>
 
 enum
Index: /trunk/src/VBox/Frontends/VirtualBox/src/VBoxVMSettingsSystem.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/VBoxVMSettingsSystem.cpp	(revision 25135)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/VBoxVMSettingsSystem.cpp	(revision 25136)
@@ -21,7 +21,11 @@
  */
 
+/* Global includes */
+#include <QHeaderView>
+
+/* Local includes */
+#include "VBoxVMSettingsSystem.h"
+#include "VBoxGlobal.h"
 #include "QIWidgetValidator.h"
-#include "VBoxVMSettingsSystem.h"
-
 #include <iprt/cdefs.h>
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/VBoxVMSettingsUSB.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/VBoxVMSettingsUSB.cpp	(revision 25135)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/VBoxVMSettingsUSB.cpp	(revision 25136)
@@ -23,5 +23,4 @@
 #include "VBoxVMSettingsUSB.h"
 #include "VBoxVMSettingsUSBFilterDetails.h"
-#include "VBoxSettingsUtils.h"
 #include "QIWidgetValidator.h"
 #include "VBoxToolBar.h"
@@ -313,5 +312,5 @@
     while (*iterator)
     {
-        QString filterName = (*iterator)->text (twUSBFilters_Name);
+        QString filterName = (*iterator)->text (0);
         int pos = regExp.indexIn (filterName);
         if (pos != -1)
@@ -462,5 +461,5 @@
     {
         filter.SetName (fd.mLeName->text().isEmpty() ? QString::null : fd.mLeName->text());
-        item->setText (twUSBFilters_Name, fd.mLeName->text());
+        item->setText (0, fd.mLeName->text());
         filter.SetVendorId (fd.mLeVendorID->text().isEmpty() ? QString::null : fd.mLeVendorID->text());
         filter.SetProductId (fd.mLeProductID->text().isEmpty() ? QString::null : fd.mLeProductID->text());
@@ -567,5 +566,5 @@
         new QTreeWidgetItem (mTwFilters);
     item->setCheckState (0, aFilter.GetActive() ? Qt::Checked : Qt::Unchecked);
-    item->setText (twUSBFilters_Name, aFilter.GetName());
+    item->setText (0, aFilter.GetName());
     item->setToolTip (0, vboxGlobal().toolTip (aFilter));
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/VBoxWarningPane.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/VBoxWarningPane.cpp	(revision 25136)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/VBoxWarningPane.cpp	(revision 25136)
@@ -0,0 +1,49 @@
+/** @file
+ *
+ * VBox frontends: Qt4 GUI ("VirtualBox"):
+ * VBoxWarningPane class implementation
+ */
+
+/*
+ * Copyright (C) 2009 Sun Microsystems, Inc.
+ *
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ *
+ * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+ * Clara, CA 95054 USA or visit http://www.sun.com if you need
+ * additional information or have any questions.
+ */
+
+/* Global includes */
+#include <QHBoxLayout>
+
+/* Local includes */
+#include "VBoxWarningPane.h"
+#include "VBoxGlobal.h"
+
+VBoxWarningPane::VBoxWarningPane(QWidget *pParent)
+    : QWidget(pParent)
+{
+    QHBoxLayout *pLayout = new QHBoxLayout(this);
+    VBoxGlobal::setLayoutMargin(pLayout, 0);
+    pLayout->addWidget(&m_icon);
+    pLayout->addWidget(&m_label);
+    setVisible(false);
+}
+
+void VBoxWarningPane::setWarningPixmap(const QPixmap &imgPixmap)
+{
+    m_icon.setPixmap (imgPixmap);
+}
+
+void VBoxWarningPane::setWarningText(const QString &strText)
+{
+    m_label.setText (strText);
+}
+
Index: /trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMSettingsSystem.ui
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMSettingsSystem.ui	(revision 25135)
+++ /trunk/src/VBox/Frontends/VirtualBox/ui/VBoxVMSettingsSystem.ui	(revision 25136)
@@ -176,5 +176,5 @@
          </property>
          <item>
-          <widget class="BootItemsTable" name="mTwBootOrder">
+          <widget class="VBoxBootTable" name="mTwBootOrder">
            <property name="sizePolicy">
             <sizepolicy hsizetype="Fixed" vsizetype="Fixed">
@@ -579,7 +579,7 @@
  <customwidgets>
   <customwidget>
-   <class>BootItemsTable</class>
+   <class>VBoxBootTable</class>
    <extends>QTreeWidget</extends>
-   <header>VBoxSettingsUtils.h</header>
+   <header>VBoxBootTable.h</header>
   </customwidget>
   <customwidget>